//+------------------------------------------------------------------+
//|                                       RSI_LEVEL_Notification.mq4 |
//|                           Copyright  2014, Tradexperts StatBars |
//|                                            http://tradexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Tradexperts StatBars"
#property link      "http://tradexperts.ru"
#property version   "1.00"
#property strict

#property indicator_separate_window
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_buffers    1
#property indicator_color1     DodgerBlue
#property indicator_level1     30.0
#property indicator_level2     70.0
#property indicator_levelcolor clrSilver
#property indicator_levelstyle STYLE_DOT

//--- buffers
double ExtRSIBuffer[];
double ExtPosBuffer[];
double ExtNegBuffer[];

enum bool_trigger
{
   on=1,
   off=0
};

enum type_signal
{
   _time=0,
   _close=1
};

enum signal_trigger{
   LEVEL=0,
   LEVEL_and_RSI
};

//--- input parameters
input int InpRSIPeriod=60; // RSI Period
extern string Sleep_Session_open = "01:00";
extern string Sleep_Session_close = "08:00";
extern int Start_position = 50;
extern double alarm_limit_notification = 3;
extern bool_trigger tel_message = on; //
extern bool_trigger mail_message = on;//
//sleep   -       ,          (   )
signal_trigger Signal_for_Notification = LEVEL_and_RSI;
//
extern string comm_1 = "--------------------LEVEL------------------------------";
extern bool_trigger LINE_UP = on; 
extern bool_trigger LINE_DOWN  = on; 
extern int LINE_alarm_target = -15;   
extern int LINE_alarm_end = 15; 
extern bool_trigger LINE_gaps_message = off; 
extern string comm_2 = "--------------------LEVEL+RSI------------------------------";
// + RSI 
extern int CLOSE_TYPE_alarm_time = 1;
extern string comm_3 = "--------------------levels------------------------------";
extern bool_trigger sell = on; 
extern bool_trigger sell_2 = on; 
extern bool_trigger buy = on; 
extern bool_trigger buy_2 = on; 
extern type_signal TYPE = _time; 

extern int alarm_target = -10;
extern int alarm_end = 10; 
extern bool_trigger gaps_message_level = off;
extern string comm_4 = "--------------------rsi------------------------------";
extern bool_trigger RSI_Sell = on;
extern bool_trigger RSI_Buy = on; 
extern type_signal RSI_TYPE = _time;

extern double RSI_alarm_target = -5; 

extern string comm_5 = "--------------------GRAPHIC DESIGN------------------------------";

extern ENUM_LINE_STYLE LINES_STYLE = STYLE_SOLID;
extern int  LINE_UPDN_WIDTH = 3;

extern color Line_UP_Color = clrRed;
extern color sell_Color = clrRed;
extern color sell_2_Color = clrRed;

extern color Line_DOWN_Color = clrBlue;
extern color buy_Color = clrBlue;
extern color buy_2_Color = clrBlue;

extern color RSI_Hi_Color = clrRed;
extern color RSI_Lo_Color = clrBlue;
extern color text_color = clrLime;
extern int text_font_size = 8;
      
datetime last_sell_1_price=0, last_sell_2_price=0, last_buy_1_price, last_buy_2_price, last_lineup_price,last_linedown_price, last_sell_rsi_price, last_buy_rsi_price;
 string short_name;
 double prev_Bid = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
  
//--- 2 additional buffers are used for counting.
   IndicatorBuffers(3);
   SetIndexBuffer(0,ExtRSIBuffer);
   SetIndexBuffer(1,ExtPosBuffer);
   SetIndexBuffer(2,ExtNegBuffer);
//--- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtRSIBuffer);
//--- name for DataWindow and indicator subwindow label
   short_name="Notification Levels("+string(InpRSIPeriod)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//--- check for input
   if(InpRSIPeriod<2)
     {
      Print("Incorrect value for input variable InpRSIPeriod = ",InpRSIPeriod);
      return(INIT_FAILED);
     }
//---
   SetIndexDrawBegin(0,InpRSIPeriod);
//---
   return(INIT_SUCCEEDED);
  }

bool Session_Check()
{
   if( TimeCurrent() > StrToTime( Sleep_Session_open) && TimeCurrent() < StrToTime( Sleep_Session_close) )
      return(false);
   else
      return(true);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int    i,pos;
   double diff, Price_Line, Price_RSI_Line;
   
   if( TYPE == _time )
   {
      if( prev_Bid == 0 )
      {
         prev_Bid = Bid;
         return(0);
      }
   }
   else
   if( TYPE == _time )
   {
      
   }
//---
   if(Bars<=InpRSIPeriod || InpRSIPeriod<2)
      return(0);
//--- counting from 0 to rates_total
   ArraySetAsSeries(ExtRSIBuffer,false);
   ArraySetAsSeries(ExtPosBuffer,false);
   ArraySetAsSeries(ExtNegBuffer,false);
   ArraySetAsSeries(close,false);
//--- preliminary calculations
   pos=prev_calculated-1;
   if(pos<=InpRSIPeriod)
     {
      //--- first RSIPeriod values of the indicator are not calculated
      ExtRSIBuffer[0]=0.0;
      ExtPosBuffer[0]=0.0;
      ExtNegBuffer[0]=0.0;
      double sump=0.0;
      double sumn=0.0;
      for(i=1; i<=InpRSIPeriod; i++)
        {
         ExtRSIBuffer[i]=0.0;
         ExtPosBuffer[i]=0.0;
         ExtNegBuffer[i]=0.0;
         diff=close[i]-close[i-1];
         if(diff>0)
            sump+=diff;
         else
            sumn-=diff;
        }
      //--- calculate first visible value
      ExtPosBuffer[InpRSIPeriod]=sump/InpRSIPeriod;
      ExtNegBuffer[InpRSIPeriod]=sumn/InpRSIPeriod;
      if(ExtNegBuffer[InpRSIPeriod]!=0.0)
         ExtRSIBuffer[InpRSIPeriod]=100.0-(100.0/(1.0+ExtPosBuffer[InpRSIPeriod]/ExtNegBuffer[InpRSIPeriod]));
      else
        {
         if(ExtPosBuffer[InpRSIPeriod]!=0.0)
            ExtRSIBuffer[InpRSIPeriod]=100.0;
         else
            ExtRSIBuffer[InpRSIPeriod]=50.0;
        }
      //--- prepare the position value for main calculation
      pos=InpRSIPeriod+1;
     }
//--- the main loop of calculations
   for(i=pos; i<rates_total && !IsStopped(); i++)
     {
      diff=close[i]-close[i-1];
      ExtPosBuffer[i]=(ExtPosBuffer[i-1]*(InpRSIPeriod-1)+(diff>0.0?diff:0.0))/InpRSIPeriod;
      ExtNegBuffer[i]=(ExtNegBuffer[i-1]*(InpRSIPeriod-1)+(diff<0.0?-diff:0.0))/InpRSIPeriod;
      if(ExtNegBuffer[i]!=0.0)
         ExtRSIBuffer[i]=100.0-100.0/(1+ExtPosBuffer[i]/ExtNegBuffer[i]);
      else
        {
         if(ExtPosBuffer[i]!=0.0)
            ExtRSIBuffer[i]=100.0;
         else
            ExtRSIBuffer[i]=50.0;
        }
     }
   
   string comment;
   comment = "LEVEL"+"\n";
   comment = comment+"target = "+DoubleToStr(alarm_target,0)+"\n";
   comment = comment+"end = "+DoubleToStr(alarm_end,0)+"\n";
   comment = comment+"LEVEL+RSI"+"\n";
   comment = comment+"target = "+DoubleToStr(RSI_alarm_target,0)+"\n";
   if( TYPE == _close )comment = comment+"type close"+"\n";
   if( TYPE == _time )comment = comment+"type time"+"\n";
   
    if( RSI_TYPE == _close )comment = comment+"RSI type close"+"\n";
   if( RSI_TYPE == _time )comment = comment+"RSI type time"+"\n";
   
   Comment(comment);
   
   string message;
   
   //----    RSI
   ExtRSIBuffer[0] = iRSI(Symbol(), Period(), InpRSIPeriod, PRICE_CLOSE, 0);
   if( RSI_Sell )
   {
      
      if( ObjectFind("RSI SELL Level") == WindowFind(short_name) )
      {
         
         if( RSI_TYPE == _time )
         {
            //Print( "  ");
            //  
            Price_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            //Print(ExtRSIBuffer[0] > Price_Line + RSI_alarm_target , " ", ExtRSIBuffer[0] < 100," ",ExtRSIBuffer[0]);
            if( ExtRSIBuffer[0] > Price_Line + RSI_alarm_target && ExtRSIBuffer[0] < 100 )
            {
               
               //          
               if( last_sell_rsi_price == 0 || TimeCurrent() - last_sell_rsi_price > alarm_limit_notification*60 )
               {
                  Print(" ");
                  if( Session_Check() )
                  {
                     SendNotification( Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr( Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     Print( Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr( Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" RSI SELL :", Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr( Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                  }
                  last_sell_rsi_price = TimeCurrent();
               }
            }
            else last_sell_rsi_price = 0;
         }
         else
         if( RSI_TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( ExtRSIBuffer[0] > Price_Line + RSI_alarm_target && ExtRSIBuffer[0] < 100 )
               {
                  //          
                  if( last_sell_rsi_price == 0 || TimeCurrent() - last_sell_rsi_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        SendNotification( Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr(  Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                        Print( Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr(  Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" RSI SELL :", Symbol()+" TF:"+TF_in_String()+" RSI SELL :"+DoubleToStr(  Bid, Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     }
                     last_sell_rsi_price = TimeCurrent();
                  }
               }
               else last_sell_rsi_price = 0;
            }
         }
      }
      else
      {
      
         ObjectCreate( "RSI SELL Level", OBJ_HLINE, WindowFind( short_name), Time[1], 70, 0,0); 
         ObjectSet( "RSI SELL Level", OBJPROP_COLOR, RSI_Hi_Color);
         ObjectSet( "RSI SELL Level", OBJPROP_STYLE, LINES_STYLE);
         
      }
   }
   if( RSI_Buy )
   {
      if( ObjectFind("RSI BUY Level") == WindowFind(short_name) )
      {
         if( RSI_TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( ExtRSIBuffer[0] < Price_Line - RSI_alarm_target && ExtRSIBuffer[0] > 0 )
            {
               //          
               if( last_buy_rsi_price == 0 || TimeCurrent() - last_buy_rsi_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     SendNotification( Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     Print( Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" RSI BUY :",Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                  }
                  last_buy_rsi_price = TimeCurrent();
               }
            }
            else last_buy_rsi_price = 0;
         }
         else
         if( RSI_TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( ExtRSIBuffer[0] < Price_Line - RSI_alarm_target && ExtRSIBuffer[0] > 0 )
               {
                  //          
                  if( last_buy_rsi_price == 0 || TimeCurrent() - last_buy_rsi_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        SendNotification( Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                        Print( Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" RSI BUY :",Symbol()+" TF:"+TF_in_String()+" RSI BUY :"+DoubleToStr( Bid ,Digits)+" RSI:"+DoubleToStr(ExtRSIBuffer[0], 2));
                     }
                     last_buy_rsi_price = TimeCurrent();
                  }
               }
               else last_buy_rsi_price = 0;
            }
         }
      }
      else
      {
         ObjectCreate( "RSI BUY Level", OBJ_HLINE, WindowFind( short_name), Time[1], 30, 0,0); 
         ObjectSet( "RSI BUY Level", OBJPROP_COLOR, RSI_Lo_Color);
         ObjectSet( "RSI BUY Level", OBJPROP_STYLE, LINES_STYLE);
      }
   }
   
   if( sell )
   {
     
      if( ObjectFind("SELL Level") == 0 )
      {
         if( !(ObjectFind("SELL Level text") == 0) )
         {
            ObjectCreate( "SELL Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "SELL Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "SELL Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "SELL Level text", "Sell Level", text_font_size,"Arial", text_color);
         }
         else
         {
            ObjectSet( "SELL Level text", OBJPROP_PRICE1, ObjectGet( "SELL Level", OBJPROP_PRICE1));
            ObjectSet( "SELL Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "SELL Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         
         if( TYPE == _time )
         {
            //Print( "  ");
            //  
            Price_Line = ObjectGet( "SELL Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            //Print(Bid > Price_Line - alarm_target*Point , " ", Bid < Price_Line + alarm_end*Point);
            if( Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
            {
               
               //          
               if( last_sell_1_price == 0 || TimeCurrent() - last_sell_1_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price SELL 1:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                     SendNotification(message );
                     Print( message);
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" Price SELL 1:",message);
                  }
                  last_sell_1_price = TimeCurrent();
               }
            }
            else
            {
               last_sell_1_price = 0;
               if( gaps_message_level == on )
               {
                  
                  if( prev_Bid < Price_Line + alarm_target*Point && Bid > Price_Line + alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 1:"+DoubleToStr( (Bid - Price_Line )/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification(message );
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 1:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "SELL Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
               {
                  //          
                  if( last_sell_1_price == 0 || TimeCurrent() - last_sell_1_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price SELL 1:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification(message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price SELL 1:", message);
                     }
                     last_sell_1_price = TimeCurrent();
                  }
               }
               else
               {
                  last_sell_1_price = 0;
                  if( gaps_message_level == on )
                  {
                     if( Close[1] < Price_Line + alarm_target*Point && Close[0] > Price_Line + alarm_end*Point )
                     {
                        //   
                        //    Bid  ,      ,   
                        if( Session_Check() )
                        {
                           message ="GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 1:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                           SendNotification( message);
                           Print( message);
                           if( mail_message == on )
                              SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 1:",message);
                        }
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "SELL Level", OBJ_HLINE, 0, Time[1], Close[0]+Start_position*Point, 0,0); 
         ObjectSet( "SELL Level", OBJPROP_COLOR, sell_Color);
         ObjectSet( "SELL Level", OBJPROP_STYLE, LINES_STYLE);
      }
   }
   if( sell_2 )
   {
      if( ObjectFind("SELL_2 Level") == 0 )
      {
         if( !(ObjectFind("SELL_2 Level text") == 0) )
         {
            ObjectCreate( "SELL_2 Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "SELL_2 Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "SELL_2 Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "SELL_2 Level text", "SELL_2 Level", text_font_size,"Arial", text_color);
         }
         else
         {
            ObjectSet( "SELL_2 Level text", OBJPROP_PRICE1, ObjectGet( "SELL_2 Level", OBJPROP_PRICE1));
            ObjectSet( "SELL_2 Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "SELL_2 Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         if( TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "SELL_2 Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
            {
               //          
               if( last_sell_2_price == 0 || TimeCurrent() - last_sell_2_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price SELL_2:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                     SendNotification( message);
                     Print( message);
                     if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price SELL 2:",message);
                  }
                  last_sell_2_price = TimeCurrent();
               }
            }
            else
            {
               last_sell_2_price = 0;
               if( gaps_message_level == on )
               {
                  if( prev_Bid < Price_Line + alarm_target*Point && Bid > Price_Line + alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 2:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 2:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "SELL_2 Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
               {
                  //          
                  if( last_sell_2_price == 0 || TimeCurrent() - last_sell_2_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price SELL_2:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price SELL 2:",message);
                     }
                     last_sell_2_price = TimeCurrent();
                  }
               }
               else
               {
                  last_sell_2_price = 0;
                  if( gaps_message_level == on )
                  {
                     if( Close[1] < Price_Line + alarm_target*Point && Close[0] > Price_Line + alarm_end*Point )
                     {
                        //   
                        //    Bid  ,      ,   
                        if( Session_Check() )
                        {
                           message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 2:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                           SendNotification( message);
                           Print( message);
                           if( mail_message == on )
                              SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price SELL 2:",message);
                        }
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "SELL_2 Level", OBJ_HLINE, 0, Time[1], Close[0] + 2*Start_position*Point, 0,0); 
         ObjectSet( "SELL_2 Level", OBJPROP_COLOR, sell_2_Color);
         ObjectSet( "SELL_2 Level", OBJPROP_STYLE, LINES_STYLE);
      }
   }
   if( LINE_DOWN )
   {
      if( ObjectFind("LINE_DOWN Level") == 0 )
      {
         if( !(ObjectFind("LINE_DOWN Level text") == 0) )
         {
            ObjectCreate( "LINE_DOWN Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "LINE_DOWN Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "LINE_DOWN Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "LINE_DOWN Level text", "LINE_DOWN Level", text_font_size,"Arial", text_color);
            
         }
         else
         {
            ObjectSet( "LINE_DOWN Level text", OBJPROP_PRICE1, ObjectGet( "LINE_DOWN Level", OBJPROP_PRICE1));
            ObjectSet( "LINE_DOWN Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "LINE_DOWN Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         if( TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "LINE_DOWN Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( Bid > Price_Line + LINE_alarm_target*Point && Bid < Price_Line + LINE_alarm_end*Point )
            {
               //          
               if( last_linedown_price == 0 || TimeCurrent() - last_linedown_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                     SendNotification( message);
                     Print( message);
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:",message);
                  }
                  last_linedown_price = TimeCurrent();
               }
            }
            else
            {
               last_linedown_price = 0;
               if( LINE_gaps_message == on )
               {
                  if( prev_Bid < Price_Line + LINE_alarm_target*Point && Bid > Price_Line + LINE_alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "LINE_DOWN Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI SELL Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid > Price_Line + LINE_alarm_target*Point && Bid < Price_Line + LINE_alarm_end*Point )
               {
                  //          
                  if( last_linedown_price == 0 || TimeCurrent() - last_linedown_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0]-Price_RSI_Line, 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:",message);
                     }
                     last_linedown_price = TimeCurrent();
                  }
               }
               else
               if( gaps_message_level == on )
               {
                  if( Close[1] < Price_Line + LINE_alarm_target*Point && Close[0] > Price_Line + LINE_alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:"+DoubleToStr( (Bid - Price_Line)/Point,0)+" RSI:"+DoubleToStr(ExtRSIBuffer[0] - Price_RSI_Line, 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_DOWN:",message);
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "LINE_DOWN Level", OBJ_HLINE, 0, Time[1], Close[0] + 3*Start_position*Point, 0,0); 
         ObjectSet( "LINE_DOWN Level", OBJPROP_COLOR, Line_DOWN_Color);
         ObjectSet( "LINE_DOWN Level", OBJPROP_STYLE, LINES_STYLE);
         ObjectSet( "LINE_DOWN Level", OBJPROP_WIDTH, LINE_UPDN_WIDTH);
      }
   }
   
   if( buy )
   {
      if( ObjectFind("BUY Level") == 0 )
      {
         if( !(ObjectFind("BUY Level text") == 0) )
         {
            ObjectCreate( "BUY Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "BUY Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "BUY Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "BUY Level text", "BUY Level", text_font_size,"Arial", text_color);
         }
         else
         {
            ObjectSet( "BUY Level text", OBJPROP_PRICE1, ObjectGet( "BUY Level", OBJPROP_PRICE1));
            ObjectSet( "BUY Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "BUY Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         if( TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "BUY Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( Bid < Price_Line - alarm_target*Point && Bid > Price_Line - alarm_end*Point )
            {
               //          
               if( last_buy_1_price == 0 || TimeCurrent() - last_buy_1_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price BUY 1:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                     SendNotification( message);
                     Print( message);
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" Price BUY 1:",message);
                  }
                  last_buy_1_price = TimeCurrent();
               }
            }
            else
            {
               last_buy_1_price = 0;
               if( gaps_message_level == on )
               {
                  if( prev_Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 1:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 1:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "BUY Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid < Price_Line - alarm_target*Point && Bid > Price_Line - alarm_end*Point )
               {
                  //          
                  if( last_buy_1_price == 0 || TimeCurrent() - last_buy_1_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price BUY 1:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price BUY 1:",message);
                     }
                     last_buy_1_price = TimeCurrent();
                  }
               }
               else
               {
                  last_buy_1_price = 0;
                  if( gaps_message_level == on )
                  {
                     if( Close[1] > Price_Line + alarm_target*Point && Close[0] < Price_Line + alarm_end*Point )
                     {
                        //   
                        //    Bid  ,      ,   
                        if( Session_Check() )
                        {
                           message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 1:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                           SendNotification( message);
                           Print( message);
                           if( mail_message == on )
                              SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 1:",message);
                        }
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "BUY Level", OBJ_HLINE, 0, Time[1], Close[0] - Start_position*Point, 0,0); 
         ObjectSet( "BUY Level", OBJPROP_COLOR, buy_Color);
         ObjectSet( "BUY Level", OBJPROP_STYLE, LINES_STYLE);
      }
   }
   if( buy_2 )
   {
      if( ObjectFind("BUY_2 Level") == 0 )
      {
         if( !(ObjectFind("BUY_2 Level text") == 0) )
         {
            ObjectCreate( "BUY_2 Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "BUY_2 Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "BUY_2 Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "BUY_2 Level text", "BUY_2 Level", text_font_size,"Arial", text_color);
         }
         else
         {
            ObjectSet( "BUY_2 Level text", OBJPROP_PRICE1, ObjectGet( "BUY_2 Level", OBJPROP_PRICE1));
            ObjectSet( "BUY_2 Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "BUY_2 Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         
         if( TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "BUY_2 Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( Bid < Price_Line - alarm_target*Point && Bid > Price_Line - alarm_end*Point )
            {
               //          
               if( last_buy_2_price == 0 || TimeCurrent() - last_buy_2_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price BUY 2:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                     SendNotification( message);
                     Print( message);
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" Price BUY 2:",message);
                  }
                  last_buy_2_price = TimeCurrent();
               }
            }
            else
            {
               last_buy_2_price = 0;
               if( gaps_message_level == on )
               {
                  if( prev_Bid > Price_Line + alarm_target*Point && Bid < Price_Line + alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 2:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 2:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "BUY_2 Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid < Price_Line - alarm_target*Point && Bid > Price_Line - alarm_end*Point )
               {
                  //          
                  if( last_buy_2_price == 0 || TimeCurrent() - last_buy_2_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price BUY 2:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price BUY 2:",message);
                     }
                     last_buy_2_price = TimeCurrent();
                  }
               }
               else
               {
                  last_buy_2_price = 0;
                  if( gaps_message_level == on )
                  {
                     if( Close[1] > Price_Line + alarm_target*Point && Close[0] < Price_Line + alarm_end*Point )
                     {
                        //   
                        //    Bid  ,      ,   
                        if( Session_Check() )
                        {
                           message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 2:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                           SendNotification( message);
                           Print( message);
                           if( mail_message == on )
                              SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price BUY 2:",message);
                        }
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "BUY_2 Level", OBJ_HLINE, 0, Time[1], Close[0] - 2*Start_position*Point, 0,0); 
         ObjectSet( "BUY_2 Level", OBJPROP_COLOR, buy_2_Color);
         ObjectSet( "BUY_2 Level", OBJPROP_STYLE, LINES_STYLE);
      }
   }
   if( LINE_UP )
   {
      if( ObjectFind("LINE_UP Level") == 0 )
      {
         if( !(ObjectFind("LINE_UP Level text") == 0) )
         {
            ObjectCreate( "LINE_UP Level text", OBJ_TEXT, 0, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)), ObjectGet( "LINE_UP Level", OBJPROP_PRICE1), 0, 0);
            ObjectSet   ( "LINE_UP Level text", OBJPROP_CORNER, ANCHOR_LEFT);
            ObjectSetText( "LINE_UP Level text", "LINE_UP Level", text_font_size,"Arial", text_color);
         }
         else
         {
            ObjectSet( "LINE_UP Level text", OBJPROP_PRICE1, ObjectGet( "LINE_UP Level", OBJPROP_PRICE1));
            ObjectSet( "LINE_UP Level text", OBJPROP_TIME1, iTime( Symbol(), Period(), WindowFirstVisibleBar()-int(WindowBarsPerChart()*0.1)));
            ObjectSet( "LINE_UP Level text", OBJPROP_CORNER, ANCHOR_LEFT);
         }
         
         if( TYPE == _time )
         {
            //  
            Price_Line = ObjectGet( "LINE_UP Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( Bid < Price_Line - LINE_alarm_target*Point && Bid > Price_Line - LINE_alarm_end*Point )
            {
               //          
               if( last_lineup_price == 0 || TimeCurrent() - last_lineup_price > alarm_limit_notification*60 )
               {
                  if( Session_Check() )
                  {
                     message = Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                     SendNotification( message);
                     Print( message);
                     if( mail_message == on )
                        SendMail( Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:",message);
                  }
                  last_lineup_price = TimeCurrent();
               }
            }
            else
            {
               last_lineup_price = 0;
               if( gaps_message_level == on )
               {
                  if( prev_Bid > Price_Line + LINE_alarm_target*Point && Bid < Price_Line + LINE_alarm_end*Point )
                  {
                     //   
                     //    Bid  ,      ,   
                     if( Session_Check() )
                     {
                        message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification( message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:",message);
                     }
                  }
               }
            }
         }
         else
         if( TYPE == _close )
         {
            //    .
            Price_Line = ObjectGet( "LINE_UP Level", OBJPROP_PRICE1);
            Price_RSI_Line = ObjectGet( "RSI BUY Level", OBJPROP_PRICE1);
            if( TimeCurrent() > Time[0]+Period()*60 - CLOSE_TYPE_alarm_time*60 ) //      CLOSE_TYPE_alarm_time 
            {
               if( Bid < Price_Line - LINE_alarm_target*Point && Bid > Price_Line - LINE_alarm_end*Point )
               {
                  //          
                  if( last_lineup_price == 0 || TimeCurrent() - last_lineup_price > alarm_limit_notification*60 )
                  {
                     if( Session_Check() )
                     {
                        message = Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                        SendNotification(message);
                        Print( message);
                        if( mail_message == on )
                           SendMail( Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:",message);
                     }
                     last_lineup_price = TimeCurrent();
                  }
               }
               else
               {
                  last_lineup_price = 0;
                  if( gaps_message_level == on )
                  {
                     if( Close[1] > Price_Line + LINE_alarm_target*Point && Close[0] < Price_Line + LINE_alarm_end*Point )
                     {
                        //   
                        //    Bid  ,      ,   
                        if( Session_Check() )
                        {
                           message = "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:"+DoubleToStr( (Price_Line - Bid)/Point,0)+" RSI:"+DoubleToStr(Price_RSI_Line - ExtRSIBuffer[0], 2);
                           SendNotification( message);
                           Print( message);
                           if( mail_message == on )
                              SendMail( "GAP!"+Symbol()+" TF:"+TF_in_String()+" Price LINE_UP:",message);
                        }
                     }
                  }
               }
            }
         }
      }
      else
      {
         ObjectCreate( "LINE_UP Level", OBJ_HLINE, 0, Time[1], Close[0] - 3*Start_position*Point, 0,0); 
         ObjectSet( "LINE_UP Level", OBJPROP_COLOR, Line_UP_Color);
         ObjectSet( "LINE_UP Level", OBJPROP_STYLE, LINES_STYLE);
         ObjectSet( "LINE_UP Level", OBJPROP_WIDTH, LINE_UPDN_WIDTH);
      }
   }
   prev_Bid = Bid;
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

string TF_in_String()
{
   if( Period() == 1 )return("M1");
   if( Period() == 5 )return("M5");
   if( Period() == 15 )return("M15");
   if( Period() == 30 )return("M30");
   if( Period() == 60 )return("H1");
   if( Period() == 240 )return("H4");
   if( Period() == PERIOD_D1 )return("D1");
   if( Period() == PERIOD_W1 )return("W1");
   if( Period() == PERIOD_MN1 )return("MN");
   
   return(IntegerToString( Period()));
}